ons.disableAutoStatusBarFill(); //- Disable the status bar margin.
var app = angular.module('app', ['onsen', 'angular-carousel', 'ngMap','chieffancypants.loadingBar', 'ngAnimate'])
    .directive('onFinishRender', function ($timeout) {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            if (scope.$last === true) {
                $timeout(function () {
                    scope.$emit('ngRepeatFinished');
                });
            }
        }
    }
});

// Map Markers Controller
var map;




app.controller('branchesController_o', function($http, $scope, $compile, $sce){

 
	$scope.isFetching = true;
	$scope.userLat = 0;
	$scope.userLng = 0;
	$scope.minDistance = 100; // Km
	$scope.markers = [];
	$scope.locations = garages;
   	    	
	
	$scope.init = function(){    	    	
	
		navigator.geolocation.getCurrentPosition(function(position){
			
			$scope.userLat = position.coords.latitude;
			$scope.userLng = position.coords.longitude;
			$scope.allLocations();
			
		}, function(error){
			console.log("Couldn't get the location of the user.");
			console.log(error);
		}, {
			maximumAge:60000,
			timeout:10000,
			enableHighAccuracy: true
		});

    }
    

	$scope.allLocations = function(){
		
		$.each($scope.locations, function( index, value ) {
         
			
			var distance = Haversine( $scope.locations[ index ].location[ 0 ],$scope.locations[ index ].location[ 1 ], $scope.userLat, $scope.userLng );

			$scope.markers.push({
				'id'		: index,
				'Nome' 	: $scope.locations[ index ].Nome,
				'content' 	: '<span  style="color:#000;font-size:10px">'
							 + $scope.locations[ index ].Morada 
							 + '</span><br><span  style="color:#000;font-size:10px">' 
							 + $scope.locations[ index ].Codlocationtal + '  ' 
							 + $scope.locations[ index ].Localidade 
							 + '</span><br><span  style="color:#000;font-size:10px"><img alt="" src="img/concessionarioslistatel.png" style="height:8px; padding-right:2px;" /> Tel: <a style="color:#000!important;text-decoration:none;" href="tel:' 
							 + $scope.locations[ index ].Telefone + '">' 
							 + $scope.locations[ index ].Telefone 
							 + '</a><br />Fax: ' 
							 + $scope.locations[ index ].Fax 
							 + '</span><br><span  style="color:red;font-size:10px"><img alt="" src="img/concessionarioslistaemail.png" style="height:8px; padding-right:2px;" /> Email: <a  style="color:#000!important;text-decoration:none;" href="mailto:' + $scope.locations[ index ].Email + '"><sapn style="color:#000;">' + $scope.locations[ index ].Email + '</span></a></span>' 
									   ,
				'Morada'	: $scope.locations[ index ].Morada ,
				'phone'		:$scope.locations[ index ].Telefone ,
				'distance'	: (Math.round(distance * 100) / 100),
				'location'	: [$scope.locations[ index ].location[ 0 ],$scope.locations[ index ].location[ 1 ]]
			});
			$scope.isFetching = false;
		});

	}

	
	
	
	 $scope.renderHtml = function (htmlCode) {
        return $sce.trustAsHtml(htmlCode);
    }

    // Get Directions
	$(document).on('click', '.get-directions', function(e){
		e.preventDefault();

		var marker = $scope.markers[$(this).attr('data-marker')];

		// Apple
        window.location.href = 'maps://maps.apple.com/?q='+marker.location[0]+','+marker.location[1];
        
        // Google Maps (Android)
		//var ref = window.open('http://maps.google.com/maps?q='+marker.location[0]+','+marker.location[1], '_system', 'location=yes');
	});
        
    // Call
	$(document).on('click', '.call-phone', function(e){

		e.preventDefault();

		var phone = $(this).attr('data-phone');
		phone = phone.replace(/\D+/g, "");

		window.open('tel:'+phone, '_system')

	});
 });

app.controller('branchesController', function($http, $scope, $compile, $sce){

 
	$scope.isFetching = true;
	$scope.userLat = 0;
	$scope.userLng = 0;
	$scope.minDistance = 100; // Km
	$scope.markers = [];
	$scope.locations = stores;
   	    	
	
	$scope.init = function(){    	    	
	
		navigator.geolocation.getCurrentPosition(function(position){
			
			$scope.userLat = position.coords.latitude;
			$scope.userLng = position.coords.longitude;
			$scope.allLocations();
			
		}, function(error){
			console.log("Couldn't get the location of the user.");
			console.log(error);
		}, {
			maximumAge:60000,
			timeout:10000,
			enableHighAccuracy: true
		});

    }
    

	$scope.allLocations = function(){
		
		$.each($scope.locations, function( index, value ) {
         
			
			var distance = Haversine( $scope.locations[ index ].location[ 0 ],$scope.locations[ index ].location[ 1 ], $scope.userLat, $scope.userLng );

			$scope.markers.push({
				'id'		: index,
				'Nome' 	: $scope.locations[ index ].Nome,
				'content' 	: '<span  style="color:#000;font-size:10px">'
							 + $scope.locations[ index ].Morada 
							 + '</span><br><span  style="color:#000;font-size:10px">' 
							 + $scope.locations[ index ].Codlocationtal + '  ' 
							 + $scope.locations[ index ].Localidade 
							 + '</span><br><span  style="color:#000;font-size:10px"><img alt="" src="img/concessionarioslistatel.png" style="height:8px; padding-right:2px;" /> Tel: <a style="color:#000!important;text-decoration:none;" href="tel:' 
							 + $scope.locations[ index ].Telefone + '">' 
							 + $scope.locations[ index ].Telefone 
							 + '</a><br />Fax: ' 
							 + $scope.locations[ index ].Fax 
							 + '</span><br><span  style="color:red;font-size:10px"><img alt="" src="img/concessionarioslistaemail.png" style="height:8px; padding-right:2px;" /> Email: <a  style="color:#000!important;text-decoration:none;" href="mailto:' + $scope.locations[ index ].Email + '"><sapn style="color:#000;">' + $scope.locations[ index ].Email + '</span></a></span>' 
									   ,
				'Morada'	: $scope.locations[ index ].Morada ,
				'phone'		:$scope.locations[ index ].Telefone ,
				'distance'	: (Math.round(distance * 100) / 100),
				'location'	: [$scope.locations[ index ].location[ 0 ],$scope.locations[ index ].location[ 1 ]]
			});
			$scope.isFetching = false;
		});

	}

	
	
	
	 $scope.renderHtml = function (htmlCode) {
        return $sce.trustAsHtml(htmlCode);
    }

    // Get Directions
	$(document).on('click', '.get-directions', function(e){
		e.preventDefault();

		var marker = $scope.markers[$(this).attr('data-marker')];

		// Apple
        window.location.href = 'maps://maps.apple.com/?q='+marker.location[0]+','+marker.location[1];
        
        // Google Maps (Android)
		//var ref = window.open('http://maps.google.com/maps?q='+marker.location[0]+','+marker.location[1], '_system', 'location=yes');
	});
        
    // Call
	$(document).on('click', '.call-phone', function(e){

		e.preventDefault();

		var phone = $(this).attr('data-phone');
		phone = phone.replace(/\D+/g, "");

		window.open('tel:'+phone, '_system')

	});
 });

// Map Markers Controller


app.controller('estacionamentoController', function($scope, $compile){
	
	$scope.$on('mapInitialized', function(event, evtMap) {
		
		map = evtMap;
		$scope.init();
		Ti.App.fireEvent('getEstacionamento', {});
    });
	
	
	$scope.setPosition = function() {
	      
			 Ti.App.fireEvent('setEstacionamento', {lat:$scope.userLat,lng:$scope.userLng, addr:$scope.addr});
			 addr =  $scope.addr;
			
	};
	
	$scope.getPosition = function() {
		
			navigator.geolocation.getCurrentPosition(function(position){
		
				$scope.userLat = position.coords.latitude;
				$scope.userLng = position.coords.longitude;
				var latlng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
				var geocoder = new google.maps.Geocoder();
			 	geocoder.geocode({'latLng': latlng}, function(results, status) {

			     if (status == google.maps.GeocoderStatus.OK) {
			       $scope.addr = results[0].formatted_address;
				}
			 
				});
			
			
		}, function(error){
			console.log("Couldn't get the location of the user.");
			console.log(error);
		}, {
			maximumAge:60000,
			timeout:10000,
			enableHighAccuracy: true
		});
		
		
		  if (addr == '') 
			 Ti.App.fireEvent('getEstacionamento', {});
			 
		   $scope.calcRoute($scope.addr,addr);
			 
			 
			
			
	};
	
	
	
	
	$scope.init = function(){    	    	
	
		
			navigator.geolocation.getCurrentPosition(function(position){
		
				$scope.userLat = position.coords.latitude;
				$scope.userLng = position.coords.longitude;
				$scope.drawMyLocation( position.coords.latitude, position.coords.longitude );
				var latlng = new google.maps.LatLng(position.coords.latitude, position.coords.longitude);
				var geocoder = new google.maps.Geocoder();
			 	geocoder.geocode({'latLng': latlng}, function(results, status) {

			     if (status == google.maps.GeocoderStatus.OK) {
			       $scope.addr = results[0].formatted_address;
				  
			       $scope.isFetching = false;
				}
			 
				});
			
			
		}, function(error){
			console.log("Couldn't get the location of the user.");
			console.log(error);
		}, {
			maximumAge:60000,
			timeout:10000,
			enableHighAccuracy: true
		});

    }
	
	 $scope.drawMyLocation = function( lat, lng){
    	
    		var pinLayer;
			var swBound = new google.maps.LatLng(lat, lng);
			var neBound = new google.maps.LatLng(lat, lng);
			var bounds = new google.maps.LatLngBounds(swBound, neBound);  
			pinLayer = new PinLayer(bounds, map);
			$scope.centerMap = [ lat, lng ];

    }
	
	
	$scope.calcRoute = function( start, end ){	
	
 	  var directionsService = new google.maps.DirectionsService();
	  var directionsDisplay = new google.maps.DirectionsRenderer();
	  directionsDisplay.setMap(map);
      directionsDisplay.setPanel(document.getElementById('directions-panel'));
	  
	  
	   var request = {
		origin: start,
		destination: end,
		travelMode: google.maps.TravelMode.DRIVING
	  };
	  directionsService.route(request, function(response, status) {
	    if (status == google.maps.DirectionsStatus.OK) {
    		  directionsDisplay.setDirections(response);
         }
     });
   }

	
	
	
	

});


app.controller('markersController_o', function($scope, $compile){
	
	$scope.$on('mapInitialized', function(event, evtMap) {
		
		map = evtMap;
		$scope.init();
    });
	
	$scope.init = function(){    	    	
	
		navigator.geolocation.getCurrentPosition(function(position){
			$scope.drawMyLocation( position.coords.latitude, position.coords.longitude );
			$scope.userLat = position.coords.latitude;
			$scope.userLng = position.coords.longitude;
		}, function(error){
			console.log("Couldn't get the location of the user.");
			console.log(error);
		}, {
			maximumAge:60000,
			timeout:10000,
			enableHighAccuracy: true
		});

    }

    $scope.drawMyLocation = function( lat, lng){
    	
    		var pinLayer;
			var swBound = new google.maps.LatLng(lat, lng);
			var neBound = new google.maps.LatLng(lat, lng);
			var bounds = new google.maps.LatLngBounds(swBound, neBound);  
			pinLayer = new PinLayer(bounds, map);
			$scope.centerMap = [ lat, lng ];

    }
	
	
	
	
	
	$scope.infoWindow = {
		title: 'Concessionários',
		content: 'content'
	};

	$scope.markers = garages;
	
    $scope.showMarker = function(event){

		$scope.marker = $scope.markers[this.id];
    	$scope.infoWindow = {
			title: '<span  style="color:#000;font-size:13px">' + $scope.marker.Nome + '</span>',
			content: '<span  style="color:#000;font-size:10px">'
			 + $scope.marker.Morada 
			 + '</span><br><span  style="color:#000;font-size:10px">' 
			 + $scope.marker.Codlocationtal + '  ' 
			 + $scope.marker.Localidade 
			 + '</span><br><span  style="color:#000;font-size:10px"><img alt="" src="img/concessionarioslistatel.png" style="height:8px; padding-right:2px;" /> Tel: <a style="color:#000!important;text-decoration:none;" href="tel:' 
			 + $scope.marker.Telefone + '">' 
			 + $scope.marker.Telefone 
			 + '</a><br />Fax: ' 
			 + $scope.marker.Fax 
			 + '</span><br><span  style="color:red;font-size:10px"><img alt="" src="img/concessionarioslistaemail.png" style="height:8px; padding-right:2px;" /> Email: <a  style="color:#000!important;text-decoration:none;" href="mailto:' + $scope.marker.Email + '"><sapn style="color:#000;">' + $scope.marker.Email + '</span></a></span>' 
                        
		};
		$scope.$apply();
		$scope.showInfoWindow(event, 'marker-info', this.getPosition());
    }

});

app.controller('markersController', function($scope, $compile){
	
	$scope.$on('mapInitialized', function(event, evtMap) {
		
		map = evtMap;
		$scope.init();
    });
	
	$scope.init = function(){    	    	
	
		navigator.geolocation.getCurrentPosition(function(position){
			$scope.drawMyLocation( position.coords.latitude, position.coords.longitude );
			$scope.userLat = position.coords.latitude;
			$scope.userLng = position.coords.longitude;
		}, function(error){
			console.log("Couldn't get the location of the user.");
			console.log(error);
		}, {
			maximumAge:60000,
			timeout:10000,
			enableHighAccuracy: true
		});

    }

    $scope.drawMyLocation = function( lat, lng){
    	
    		var pinLayer;
			var swBound = new google.maps.LatLng(lat, lng);
			var neBound = new google.maps.LatLng(lat, lng);
			var bounds = new google.maps.LatLngBounds(swBound, neBound);  
			pinLayer = new PinLayer(bounds, map);
			$scope.centerMap = [ lat, lng ];

    }
	
	
	
	
	
	$scope.infoWindow = {
		title: 'Concessionários',
		content: 'content'
	};

	$scope.markers = stores;
	
    $scope.showMarker = function(event){

		$scope.marker = $scope.markers[this.id];
    	$scope.infoWindow = {
			title: '<span  style="color:#000;font-size:13px">' + $scope.marker.Nome + '</span>',
			content: '<span  style="color:#000;font-size:10px">'
			 + $scope.marker.Morada 
			 + '</span><br><span  style="color:#000;font-size:10px">' 
			 + $scope.marker.Codlocationtal + '  ' 
			 + $scope.marker.Localidade
			 + '</span><br><span  style="color:#000;font-size:10px"><img alt="" src="img/concessionarioslistatel.png" style="height:8px; padding-right:2px;" /> Tel: <a style="color:#000!important;text-decoration:none;" href="tel:' 
			 + $scope.marker.Telefone + '">' 
			 + $scope.marker.Telefone 
			 + '</a><br />Fax: ' 
			 + $scope.marker.Fax 
			 + '</span><br><span  style="color:red;font-size:10px"><img alt="" src="img/concessionarioslistaemail.png" style="height:8px; padding-right:2px;" /> Email: <a  style="color:#000!important;text-decoration:none;" href="mailto:' + $scope.marker.Email + '"><sapn style="color:#000;">' + $scope.marker.Email + '</span></a></span>' 
                        
		};
		$scope.$apply();
		$scope.showInfoWindow(event, 'marker-info', this.getPosition());
    }

});



// Math Functions
function Deg2Rad( deg ) {
   return deg * Math.PI / 180;
}

// Get Distance between two lat/lng points using the Haversine function
// First published by Roger Sinnott in Sky & Telescope magazine in 1984 ("Virtues of the Haversine")
function Haversine( lat1, lon1, lat2, lon2 ){
	
    var R = 6372.8; // Earth Radius in Kilometers

    var dLat = Deg2Rad(lat2-lat1);  
    var dLon = Deg2Rad(lon2-lon1);  

    var a = Math.sin(dLat/2) * Math.sin(dLat/2) + 
                    Math.cos(Deg2Rad(lat1)) * Math.cos(Deg2Rad(lat2)) * 
                    Math.sin(dLon/2) * Math.sin(dLon/2);  
    var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1-a)); 
    var d = R * c; 

    // Return Distance in Kilometers
	
    return d;
}

// Pulse Marker Icon
function PinLayer(bounds, map) {
    this.bounds = bounds;
    this.setMap(null);
    this.setMap(map);
}

PinLayer.prototype = new google.maps.OverlayView();

PinLayer.prototype.onAdd = function() {

	// Container
	var container = document.createElement('DIV');
	container.className = "pulse-marker";

	// Pin
    var marker = document.createElement('DIV');
    marker.className = "pin";

    // Pulse
    var pulse = document.createElement('DIV');
    pulse.className = 'pulse';

    container.appendChild(marker);
    container.appendChild(pulse);

    this.getPanes().overlayLayer.appendChild(container);

    container.appendChild(document.createElement("DIV"));
    this.div = container;
}

PinLayer.prototype.draw = function() {
    var overlayProjection = this.getProjection();
    var sw = overlayProjection.fromLatLngToDivPixel(this.bounds.getSouthWest());
    var ne = overlayProjection.fromLatLngToDivPixel(this.bounds.getNorthEast());
    var div = this.div;
    div.style.left = sw.x - 8 + 'px';
    div.style.top = ne.y - 15 + 'px';
}


function recPwd()  {
 	ons.createDialog('recPwd.html').then(function(dialog) {
      dialog.show();
    });

}



function changeAlert(o,m) {
    
    
        var scope = angular.element(document.getElementById('pageINI')).scope();    

        scope.$apply(function () {
             scope.showPopOver(o,m);
             setTimeout(function () { hideAlert() }, 1500);
        });


} 


function hideAlert() {
	
	
		var scope = angular.element(document.getElementById('pageINI')).scope();	

		scope.$apply(function () {
			 scope.hidePopOver();
		});


}


function zeroPad(num, places) {
  var zero = places - num.toString().length + 1;
  return Array(+(zero > 0 && zero)).join("0") + num;
}

function yyyymmdd(dateIn) {
   var yyyy = dateIn.getFullYear();
   var mm =  zeroPad(dateIn.getMonth()+1,2); // getMonth() is zero-based
   var dd  = zeroPad(dateIn.getDate(),2);
   return String(yyyy + '-' +  mm + '-' + dd); // Leading zeros for mm and dd
}

var today = new Date();

document.addEventListener("pageinit", function(e) {
	
	
 console.log(e.target.id);
	if (e.target.id != "")
	Ti.App.fireEvent('trackEventSiva', {category : 'tab', action:e.target.id });		
	
  $('.page__background').attr('style', 'background-color: #1E1E1E !important');		
  
  if (e.target.id == "news") {	 
   $('.page__background').attr('style', 'background-color: #1E1E1E !important');		 
   loadnews();
  }
  
  if (e.target.id == "msg") {
    $('.page__background').attr('style', 'background-color: #1E1E1E !important');			  
   loadmsg();
  }
  
   if (e.target.id == "Automoveis") {
	 RefreshComboAutomovelList(userid);

	 
  }
  

  if (e.target.id == "news_1") {
	  
	    $('.page__background').attr('style', 'background-color: #1E1E1E !important');		
	   
	   $('#n1_image').attr('src', obj_news[news_type].imagem);
	   $('#n1_body').html('<b>' + obj_news[news_type].titulo + '</b><br><br><span font-size:8px!important;">'  + obj_news[news_type].data + '</span><br><hr>' + obj_news[news_type].corpo + '<br><br>');
  }

  if (e.target.id == "msg_1") {
	   $('.page__background').attr('style', 'background-color: #1E1E1E !important');		
	   $('#n1_image').attr('src', obj_msg[news_type].imagem);
	   $('#m1_body').html('<b>' + obj_msg[news_type].titulo + '</b><br><br><span font-size:8px!important;">'  + obj_msg[news_type].data + '</span><br><br><hr>' + obj_msg[news_type].corpo + '<br><br>');
  }
  
   if (e.target.id == "testdrive") {
	 RefreshComboModelo('A');
	 PopulateComboConcessionarios();
	$('#MarcacaoTestDrive_Nome').val(nome);
	$('#MarcacaoTestDrive_Email').val(email);
	$('#MarcacaoTestDrive_Telefone').val(telefone);
	$('#MarcacaoTestDrive_Data').val(yyyymmdd(today));
   }
   
   if (e.target.id == "automovel") {
	 RefreshComboModeloMA('A');
	 PopulateComboConcessionariosMA();
	
   }
   
    if (e.target.id == "automovel_editar") {
	 
	 PopulateAuto();
	
   }
   
   if (e.target.id == "luzes") {
	   

	if (userid  != "")	 { 
       getCon();
	 }
	
   }
   
   
    
   if (e.target.id == "oficina") {
	 PopulateComboConcessionariosOficina();
	 $('#MarcacaoOficina_Data').val(yyyymmdd(today));
	  PopulateOficina();
	
   }
   
   if (e.target.id == "pref") {
      PopulatePref();
    }
	
	 if (e.target.id == "home_page") {
	  if (userid  == "")	 { 
       $('#hp_bar_login').show()
	   $('#hp_bar_editar_dados').hide();
	 }
	 else  { 
       $('#hp_bar_login').hide()
	   $('#hp_bar_editar_dados').show();
	 }
    }
	
	
  
}, false);


 
